
#include<windows.h>
#include<math.h>
#include"resource.h"

#include "DSP.H"
#include"lice/lice/lice.h"

#include"KPointerList.h"


#define WND_WIDTH 202
#define WND_HEIGHT 259
#define SLIDER_THUMB_WIDTH 15

static char confPath[MAX_PATH];

int vbassEnabled=0;
double vbass_gain=0.5;

double BassFreq=0.002357;
double BassGain=10.5;
double TrebFreq=0.183077;
double TrebGain=0.9;

double PreAmp=1.0;

double f1p0=0.0;
double f1p1=0.0;
double f1p2=0.0;
double f1p3=0.0;

double f2p0=0.0;
double f2p1=0.0;
double f2p2=0.0;
double f2p3=0.0;

double sdm3=0.0;
double sdm2=0.0;
double sdm1=0.0;

double lowpass_l=0.0;
double lowpass_r=0.0;

//====== bass osc ==========

double osc_bass_freq=65.0;
double adj= 2.0*3.14159*osc_bass_freq/44100.0;
double pos=0.0;
double basstone=0.0;
double btvelocity_l=0.0;
double btvelocity_r=0.0;

//==========================


HINSTANCE hInstance;

LICE_IBitmap* donateBtnImage1;
LICE_IBitmap* donateBtnImage2;
LICE_IBitmap* ebsBtnImage1;
LICE_IBitmap* ebsBtnImage2;
LICE_IBitmap* ebsBtnImage3;
LICE_IBitmap* aboutBtnImage1;
LICE_IBitmap* aboutBtnImage2;
LICE_IBitmap* closeBtnImage1;
LICE_IBitmap* closeBtnImage2;
LICE_IBitmap* sliderImage;
LICE_IBitmap* backImage;
LICE_IBitmap* aboutBackImage;
LICE_SysBitmap *backBuffer;
LICE_SysBitmap *aboutBackBuffer;


HWND mainWindow,aboutWindow;

// client area drag data
bool windowDraging;
int cld_mouse_x;
int cld_mouse_y;

class Component
{
protected:
	int compX,compY,compWidth,compHeight;

public:
	Component()
	{
		compX=0;
		compY=0;
		compWidth=100;
		compHeight=100;
	}

	virtual void SetPosition(int x,int y){compX=x;compY=y;}
	virtual bool IsMouseWithinArea(int x,int y)
	{
		int relX=x-compX;
		int relY=y-compY;

		if( (0<relX) && (relX<=compWidth) && (0<relY) && (relY<=compHeight) )
		{
			return true;
		}
		return false;
	}
	virtual void OnMouseLDown(int xpos, int ypos){}
	virtual void OnMouseLUp(int xpos, int ypos){}
	virtual void OnMouseMove(int xpos, int ypos,WPARAM fwKeys){}
	virtual void OnMouseOver(WPARAM fwKeys){}
	virtual void OnMouseLost(WPARAM fwKeys){}

	virtual void OnPaint(LICE_SysBitmap *canvas){}

	virtual ~Component(){}
};

Component* mouseCapture;

class Slider : public Component
{
protected:
	int sld_mouse_x;
	int thumbDeltaX;
	int sliderID;

public:
	Slider(int sliderID)
	{
		compWidth=127;
		compHeight=10;
		sld_mouse_x=0;
		thumbDeltaX=0;
		this->sliderID=sliderID;
		thumbDeltaX=0;
	}

	void OnPaint(LICE_SysBitmap *canvas)
	{
		LICE_Blit(canvas,sliderImage,compX+thumbDeltaX,compY,0,0,SLIDER_THUMB_WIDTH,10,1.0,LICE_BLIT_USE_ALPHA);
	}

	void OnSliderChange(int value)
	{
		switch(sliderID)
		{
			case 1:
				BassFreq=( (value*(double)8.0)/(double)100000.0 )+(double)0.002357;
				break;
			case 2:
				BassGain=(value/(double)100)*7.0;
				break;
			case 3:
				TrebFreq=( (value*(double)2.0)/(double)1000.0 )+(double)0.183077;
				break;
			case 4:
				TrebGain=(value/(double)100)*3.0;
				break;
			case 5:
				PreAmp=(value/(double)100)*2.0;
				break;
			case 6:
				{
					osc_bass_freq=( (value/(double)100.0)*(double)40.0 )+(double)40.0;
					adj= 2.0*3.14159*osc_bass_freq/44100.0;
				}
				break;
			case 7:
				vbass_gain=(value/(double)100.0)*(double)2.0;
				break;
		}
	}

	void OnMouseLDown(int xpos, int ypos)
	{
		mouseCapture=this;
		sld_mouse_x = xpos;
		SetCapture(mainWindow);
		int thumbStartX=compX+thumbDeltaX;
		int thumbStopX=thumbStartX+SLIDER_THUMB_WIDTH;
		if( (sld_mouse_x<thumbStartX) || (thumbStopX<sld_mouse_x) ) // left click on path!
		{
			if(sld_mouse_x< (compX+SLIDER_THUMB_WIDTH) )
			{
				thumbDeltaX=0;
				OnSliderChange(0);
				InvalidateRect(mainWindow, NULL, TRUE);
			}else if( sld_mouse_x > ((compX+127)-SLIDER_THUMB_WIDTH) )
			{
				thumbDeltaX=112;
				OnSliderChange(100);
				InvalidateRect(mainWindow, NULL, TRUE);
			}else
			{
				thumbDeltaX=(sld_mouse_x-compX)-7;
				OnSliderChange((thumbDeltaX/(double)112.0)*(double)100.0);
				InvalidateRect(mainWindow, NULL, TRUE);
			}
		}
	}

	void OnMouseLUp(int xpos, int ypos)
	{
		mouseCapture=0;
		ReleaseCapture();
	}

	void OnMouseMove(int xpos, int ypos,WPARAM fwKeys)
	{
		if(mouseCapture==this)
		{
			POINT pos;
			GetCursorPos(&pos);
			ScreenToClient(mainWindow,&pos);
			int tmp=thumbDeltaX;
			tmp+=pos.x-sld_mouse_x;
			if( (-1<tmp) && (tmp<113) )
			{
				thumbDeltaX=tmp;
				sld_mouse_x=pos.x;
				OnSliderChange((thumbDeltaX/(double)112.0)*(double)100.0);
				InvalidateRect(mainWindow, NULL, TRUE);
			}
		}
	}

	void SetValue(int value)
	{
		thumbDeltaX=(value/(double)100.0)*(double)112.0;
	}

	int GetValue()
	{
		return (thumbDeltaX/(double)112.0)*(double)100.0;
	}

};

class Button : public Component
{
protected:
	bool down;
	LICE_IBitmap* image1;
	LICE_IBitmap* image2;
public:
	Button(LICE_IBitmap* image1,LICE_IBitmap* image2)
	{
		this->image1=image1;
		this->image2=image2;
		down=false;
		compWidth=image1->getWidth();
		compHeight=image1->getHeight();
	}

	void OnPaint(LICE_SysBitmap *canvas)
	{
		LICE_Blit(canvas,down?image2:image1,compX,compY,0,0,compWidth,compHeight,1.0,LICE_BLIT_USE_ALPHA);
	}

	void OnMouseLDown(int xpos, int ypos)
	{
		down=true;
		InvalidateRect(mainWindow, NULL, TRUE);
	}

	void OnMouseLUp(int xpos, int ypos)
	{
		if(down)
			OnPress();

		down=false;
		InvalidateRect(mainWindow, NULL, TRUE);
	}

	void OnMouseLost(WPARAM fwKeys)
	{
		down=false;
		InvalidateRect(mainWindow, NULL, TRUE);
	}

	virtual void OnPress(){}

	virtual ~Button()
	{
	}
};

class CloseButton : public Button
{
public:
	CloseButton(LICE_IBitmap* image1,LICE_IBitmap* image2):Button(image1,image2){}

	void OnPress()
	{
		SendMessage(mainWindow,WM_CLOSE,0,0);
	}

};

class DonateButton : public Button
{
public:
	DonateButton(LICE_IBitmap* image1,LICE_IBitmap* image2):Button(image1,image2){}

	void OnPress()
	{
		ShellExecuteA(0, "open","https://www.alertpay.com/checkout?BDE9eXRpdG5hdXFfcGEmPT1nWlJzeEV2R2ViK3g5ZWZJbHZqMVQyPWRpdGN1ZG9ycF9wYQQ=", NULL, NULL, SW_SHOWNORMAL);
	}

};

class AboutButton : public Button
{
public:
	AboutButton(LICE_IBitmap* image1,LICE_IBitmap* image2):Button(image1,image2){}

	void OnPress()
	{
		ShowWindow(aboutWindow,SW_SHOW);
		SetCapture(aboutWindow);
	}

};

class EBSButton : public Component
{
protected:
	bool pressed;
	bool down;
	LICE_IBitmap* image1;
	LICE_IBitmap* image2;
	LICE_IBitmap* image3;
public:
	EBSButton(LICE_IBitmap* image1,LICE_IBitmap* image2,LICE_IBitmap* image3)
	{
		pressed=false;
		down=false;

		this->image1=image1;
		this->image2=image2;
		this->image3=image3;

		compWidth=image1->getWidth();
		compHeight=image1->getHeight();
	}

	void OnPaint(LICE_SysBitmap *canvas)
	{
		LICE_IBitmap* tmpImg;
		if(down)
		{
			tmpImg=image2; // down
		}else if(pressed)
		{
			tmpImg=image1; // on
		}else
		{
			tmpImg=image3; // off
		}
		
		LICE_Blit(canvas,tmpImg,compX,compY,0,0,compWidth,compHeight,1.0,LICE_BLIT_USE_ALPHA);
	}

	void OnMouseLDown(int xpos, int ypos)
	{
		down=true;
		InvalidateRect(mainWindow, NULL, TRUE);
	}

	void OnMouseLUp(int xpos, int ypos)
	{
		if(down)
			OnPress();

		down=false;
		InvalidateRect(mainWindow, NULL, TRUE);
	}

	void OnMouseLost(WPARAM fwKeys)
	{
		down=false;
		InvalidateRect(mainWindow, NULL, TRUE);
	}

	void OnPress()
	{
		if(pressed)
			pressed=false;
		else
			pressed=true;

		vbassEnabled=pressed?1:0;
	}

	void SetPressedState(bool state)
	{
		pressed=state;
	}

	bool IsPressed()
	{
		return pressed;
	}
};

KPointerList<Component*> *componentList;
Component* mouseOverComponent;
Slider *slider1,*slider2,*slider3,*slider4,*slider5,*slider6,*slider7;
CloseButton* closeButton;
AboutButton* aboutButton;
EBSButton* ebsButton;
DonateButton* donateButton;

Component* GetComponentAt(int xPos,int yPos)
{
	for(int i=0;i<componentList->GetSize();i++)
	{
		Component* component=componentList->GetPointer(i);
		if(component->IsMouseWithinArea(xPos,yPos))
		{
			return component;
		}
	}
	return 0;
}

void OnMouseMove(int xPos,int yPos,WPARAM fwKeys)
{
	if(windowDraging) // client area drag!
	{
		POINT pos;
		GetCursorPos(&pos);
		SetWindowPos(mainWindow,0,pos.x-cld_mouse_x,pos.y-cld_mouse_y,0,0,SWP_NOREPOSITION|SWP_NOSIZE);
	}else // send event to appropriate component!
	{
		if(mouseCapture)
		{
			mouseCapture->OnMouseMove(xPos,yPos,fwKeys);
		}else
		{
			Component* component=GetComponentAt(xPos,yPos);

			if(component)// mouse is on component!
			{
				if(component==mouseOverComponent)// mouse is still on prev comp!
				{
					component->OnMouseMove(xPos,yPos,fwKeys);
				}else // mouse is on new component!
				{
					if(mouseOverComponent)// tell it to prev comp!
						mouseOverComponent->OnMouseLost(fwKeys);

					mouseOverComponent=component;// new mouse over comp!
					mouseOverComponent->OnMouseOver(fwKeys);
				}				
			}else // mouse is not on component!
			{
				if(mouseOverComponent)// tell it to prev comp!
				{			
					mouseOverComponent->OnMouseLost(fwKeys);
					mouseOverComponent=0;
				}
			}
		}
	}
}

void OnMouseLDown(int xPos,int yPos)
{
	Component* component=GetComponentAt(xPos,yPos);

	if(component) // LDown on component!
	{
		component->OnMouseLDown(xPos,yPos); // send event!
	}else // LDown for client area drag or resize!
	{
		windowDraging=true;
		SetCapture(mainWindow);

		cld_mouse_x = xPos;
		cld_mouse_y = yPos;
	}
}

void OnMouseLUp(int xPos,int yPos)
{
	if(windowDraging) // client area drag!
	{
		ReleaseCapture();
		windowDraging=false;
	}else // send event to appropriate component!
	{
		if(mouseCapture)
		{
			mouseCapture->OnMouseLUp(xPos,yPos);
		}else
		{
			Component* component=GetComponentAt(xPos,yPos);

			if(component)// mouse is on component!
			{
				component->OnMouseLUp(xPos,yPos);
			}
		}
	}
}

BOOL CALLBACK AboutDialogProc(
  HWND hwndDlg,  // handle to dialog box
  UINT uMsg,     // message
  WPARAM wParam, // first message parameter
  LPARAM lParam  // second message parameter
)
{
	switch(uMsg)
	{
		case WM_INITDIALOG:
			{
				aboutWindow=hwndDlg;
				aboutBackBuffer=new LICE_SysBitmap(147 ,174);
				SetWindowPos(hwndDlg,0,0,0,147,171,SWP_NOMOVE|SWP_NOREPOSITION);

				aboutBackImage=LICE_LoadPNGFromResource(hInstance,IDR_PNG10);
			}
			return FALSE;
		case WM_PAINT:
			{
				HDC hdc;
				PAINTSTRUCT ps;
				hdc=BeginPaint(hwndDlg,&ps);

				LICE_Blit(aboutBackBuffer,aboutBackImage,0,0,0,0,147,171,1.0,LICE_BLIT_USE_ALPHA);	

				BitBlt(hdc,0,0,147,171,aboutBackBuffer->getDC(),0,0,SRCCOPY);
				EndPaint(hwndDlg,&ps);
			}
			break;
		case WM_LBUTTONDOWN:
		case WM_RBUTTONDOWN:
		case WM_MBUTTONDOWN:
			{
				ReleaseCapture();
				ShowWindow(aboutWindow,SW_HIDE);
			}
			break;
		case WM_DESTROY:
			{
				ShowWindow(mainWindow,SW_HIDE);
				EndDialog(hwndDlg,0);
				delete aboutBackImage;
				delete aboutBackBuffer;
			}
			break;
		default:
			return FALSE;
	}

	return TRUE;
}

BOOL CALLBACK DialogProc(
  HWND hwndDlg,  // handle to dialog box
  UINT uMsg,     // message
  WPARAM wParam, // first message parameter
  LPARAM lParam  // second message parameter
)
{
	switch(uMsg)
	{
		case WM_INITDIALOG:
			{
				mainWindow=hwndDlg;
				windowDraging=false;
				mouseCapture=0;

				backImage=LICE_LoadPNGFromResource(hInstance,IDR_PNG1);
				sliderImage=LICE_LoadPNGFromResource(hInstance,IDR_PNG2);
				closeBtnImage1=LICE_LoadPNGFromResource(hInstance,IDR_PNG3);
				closeBtnImage2=LICE_LoadPNGFromResource(hInstance,IDR_PNG4);
				aboutBtnImage1=LICE_LoadPNGFromResource(hInstance,IDR_PNG5);
				aboutBtnImage2=LICE_LoadPNGFromResource(hInstance,IDR_PNG6);
				ebsBtnImage1=LICE_LoadPNGFromResource(hInstance,IDR_PNG7);
				ebsBtnImage2=LICE_LoadPNGFromResource(hInstance,IDR_PNG8);
				ebsBtnImage3=LICE_LoadPNGFromResource(hInstance,IDR_PNG9);
				donateBtnImage1=LICE_LoadPNGFromResource(hInstance,IDR_PNG11);
				donateBtnImage2=LICE_LoadPNGFromResource(hInstance,IDR_PNG12);

				backBuffer=new LICE_SysBitmap(WND_WIDTH ,WND_HEIGHT);
				SetWindowPos(hwndDlg,0,0,0,WND_WIDTH,WND_HEIGHT,SWP_NOMOVE|SWP_NOREPOSITION);

				componentList=new KPointerList<Component*>();
				mouseOverComponent=0;

				slider1=new Slider(1);
				slider1->SetPosition(62,40);
				slider2=new Slider(2);
				slider2->SetPosition(62,68);
				slider3=new Slider(3);
				slider3->SetPosition(62,98);
				slider4=new Slider(4);
				slider4->SetPosition(62,127);
				slider5=new Slider(5);
				slider5->SetPosition(62,157);
				slider6=new Slider(6);
				slider6->SetPosition(62,205);
				slider7=new Slider(7);
				slider7->SetPosition(62,231);

				componentList->AddPointer(slider1);
				componentList->AddPointer(slider2);
				componentList->AddPointer(slider3);
				componentList->AddPointer(slider4);
				componentList->AddPointer(slider5);
				componentList->AddPointer(slider6);
				componentList->AddPointer(slider7);

				int value=GetPrivateProfileIntA("dsp_citrus","bass_freq",83,confPath);
				BassFreq=( (value*(double)8.0)/(double)100000.0 )+(double)0.002357;
				slider1->SetValue(value);

				value=GetPrivateProfileIntA("dsp_citrus","bass",25,confPath);
				BassGain=(value/(double)100)*7.0;
				slider2->SetValue(value);

				value=GetPrivateProfileIntA("dsp_citrus","treb_freq",0,confPath);
				TrebFreq=( (value*(double)2.0)/(double)1000.0 )+(double)0.183077;
				slider3->SetValue(value);

				value=GetPrivateProfileIntA("dsp_citrus","treb",47,confPath);
				TrebGain=(value/(double)100)*3.0;
				slider4->SetValue(value);

				value=GetPrivateProfileIntA("dsp_citrus","preamp",70,confPath);
				PreAmp=(value/(double)100)*2.0;
				slider5->SetValue(value);

				value=GetPrivateProfileIntA("dsp_citrus","vbass_freq",17,confPath);
				osc_bass_freq=( (value/(double)100.0)*(double)40.0 )+(double)40.0;
				adj= 2.0*3.14159*osc_bass_freq/44100.0;
				slider6->SetValue(value);

				value=GetPrivateProfileIntA("dsp_citrus","vbass_gain",47,confPath);
				vbass_gain=(value/(double)100.0)*(double)2.0;
				slider7->SetValue(value);

				vbassEnabled=GetPrivateProfileIntA("dsp_citrus","vbass_enable",1,confPath);

				closeButton=new CloseButton(closeBtnImage1,closeBtnImage2);
				closeButton->SetPosition(185,8);
				componentList->AddPointer(closeButton);

				aboutButton=new AboutButton(aboutBtnImage1,aboutBtnImage2);
				aboutButton->SetPosition(7,8);
				componentList->AddPointer(aboutButton);

				ebsButton=new EBSButton(ebsBtnImage1,ebsBtnImage2,ebsBtnImage3);
				ebsButton->SetPosition(8,183);
				ebsButton->SetPressedState(vbassEnabled?true:false);
				componentList->AddPointer(ebsButton);

				donateButton=new DonateButton(donateBtnImage1,donateBtnImage2);
				donateButton->SetPosition(23,8);
				componentList->AddPointer(donateButton);

				InvalidateRect(mainWindow, NULL, TRUE);
			}
			return FALSE;
		case WM_PAINT:
			{
				HDC hdc;
				PAINTSTRUCT ps;
				hdc=BeginPaint(hwndDlg,&ps);

				LICE_Blit(backBuffer,backImage,0,0,0,0,WND_WIDTH,WND_HEIGHT,1.0,LICE_BLIT_USE_ALPHA);

				for(int i=0;i<componentList->GetSize();i++)
				{
					Component *component=componentList->GetPointer(i);
					component->OnPaint(backBuffer);
				}	

				BitBlt(hdc,0,0,WND_WIDTH,WND_HEIGHT,backBuffer->getDC(),0,0,SRCCOPY);
				EndPaint(hwndDlg,&ps);
			}
			break;
		case WM_ERASEBKGND:
			break;
		case WM_MOUSEMOVE:
			OnMouseMove(LOWORD(lParam),HIWORD(lParam),wParam);
			break;
		case WM_LBUTTONDOWN:
			OnMouseLDown(LOWORD(lParam),HIWORD(lParam));
			break;
		case WM_LBUTTONUP:
			OnMouseLUp(LOWORD(lParam),HIWORD(lParam));
			break;
		case WM_CLOSE:
			{
				ShowWindow(mainWindow,SW_HIDE);
				char strValue[16];
				wsprintfA(strValue,"%d", 0);
				WritePrivateProfileStringA("dsp_citrus","gui",strValue,confPath);
			}
			break;
		case WM_DESTROY:
			{
				ShowWindow(mainWindow,SW_HIDE);

				char strValue[16];

				int value=slider2->GetValue();
				wsprintfA(strValue,"%d", value);
				WritePrivateProfileStringA("dsp_citrus","bass",strValue,confPath);

				value=slider4->GetValue();
				wsprintfA(strValue,"%d", value);
				WritePrivateProfileStringA("dsp_citrus","treb",strValue,confPath);

				value=slider5->GetValue();
				wsprintfA(strValue,"%d", value);
				WritePrivateProfileStringA("dsp_citrus","preamp",strValue,confPath);

				value=slider1->GetValue();
				wsprintfA(strValue,"%d", value);
				WritePrivateProfileStringA("dsp_citrus","bass_freq",strValue,confPath);

				value=slider3->GetValue();
				wsprintfA(strValue,"%d", value);
				WritePrivateProfileStringA("dsp_citrus","treb_freq",strValue,confPath);

				value=slider6->GetValue();
				wsprintfA(strValue,"%d", value);
				WritePrivateProfileStringA("dsp_citrus","vbass_freq",strValue,confPath);

				value=slider7->GetValue();
				wsprintfA(strValue,"%d", value);
				WritePrivateProfileStringA("dsp_citrus","vbass_gain",strValue,confPath);

				wsprintfA(strValue,"%d", vbassEnabled);
				WritePrivateProfileStringA("dsp_citrus","vbass_enable",strValue,confPath);

				RECT rect;
				GetWindowRect(mainWindow,&rect);
				wsprintfA(strValue,"%d", rect.left);
				WritePrivateProfileStringA("dsp_citrus","x",strValue,confPath);
				wsprintfA(strValue,"%d", rect.top);
				WritePrivateProfileStringA("dsp_citrus","y",strValue,confPath);

				EndDialog(hwndDlg,0);

				delete donateBtnImage2;
				delete donateBtnImage1;
				delete ebsBtnImage3;
				delete ebsBtnImage2;
				delete ebsBtnImage1;
				delete aboutBtnImage1;
				delete aboutBtnImage2;
				delete closeBtnImage2;
				delete closeBtnImage1;
				delete sliderImage;
				delete backImage;
				delete backBuffer;

				componentList->DeleteAll();
				delete componentList;
			}
			break;
		default:
			return FALSE;
	}

	return TRUE;
	
}

winampDSPModule *getModule(int which);

void config(struct winampDSPModule *this_mod);
int init(struct winampDSPModule *this_mod);
void quit(struct winampDSPModule *this_mod);
int modify_samples(struct winampDSPModule *this_mod, short int *samples, int numsamples, int bps, int nch, int srate);


int modify_samples(struct winampDSPModule *this_mod, short int *samples, int numsamples, int bps, int nch, int srate)
{
	int x = numsamples;
	if (bps == 16)
	{
		short *a = samples;
		if (nch == 2) while (x--)
		{
			int left, right;
			left = a[1];
			right = a[0];

			double spl0=left/(double)32768;
			double spl1=right/(double)32768;

			double l=0.0;
			double h=0.0;


			if(vbassEnabled)
			{
				basstone=cos(pos);

				pos=pos+adj;
				if(pos>= (2.0*3.14159))
				{
					pos-=2.0*3.14159;
				}
			}

			//=========== left channel ==================

			f1p0  = f1p0 + (BassFreq * (spl0  - f1p0)) ;
			f1p1  = f1p1 + (BassFreq* (f1p0 - f1p1));
			f1p2  = f1p2 + (BassFreq * (f1p1 - f1p2));
			f1p3  = f1p3 + (BassFreq * (f1p2 - f1p3));

			l= f1p3;

			l=l*BassGain; // bass gain
			l=(l*0.1)+(lowpass_l*0.9); // apply simple lowpass for bass which avoids dynamic pushes...
			if(l>15.0)l=15.0;
			lowpass_l=l;

			l/=15.0;
			double limitter=(0.3/(double)8.0)*BassGain;
			if (l < (-1*limitter) ) l = (-1*limitter);
			if (l > limitter) l = limitter;

			f2p0  = f2p0 + (TrebFreq * (spl0   - f2p0));
			f2p1  = f2p1 + (TrebFreq * (f2p0 - f2p1));
			f2p2  = f2p2 + (TrebFreq * (f2p1 - f2p2));
			f2p3  = f2p3 + (TrebFreq * (f2p2 - f2p3));

			h= sdm3 - f2p3;
			h=h*TrebGain; // hi freq gain
			if(h>3.0)h=3.0;

			sdm3   = sdm2;
			sdm2   = sdm1;
			sdm1   = spl0;
			
			if(vbassEnabled)
			{
				if(btvelocity_l<=(l/(25.0/15.0)))
				{
					btvelocity_l=l/(25.0/15.0);
				}
				else
				{
					btvelocity_l-=0.000001;
				}
				spl0=(l/2.0)+((basstone*btvelocity_l)*vbass_gain)+(h/18.0);
			}else // vbass not enabled!
			{
				spl0=(h/18.0)+l;
			}		

			//=========== right channel ===============

			f1p0  = f1p0 + (BassFreq * (spl1  - f1p0)) ;
			f1p1  = f1p1 + (BassFreq * (f1p0 - f1p1));
			f1p2  = f1p2 + (BassFreq * (f1p1 - f1p2));
			f1p3  = f1p3 + (BassFreq * (f1p2 - f1p3));

			l= f1p3;

			l=l*BassGain; // bass gain
			l=(l*0.1)+(lowpass_r*0.9); // apply simple lowpass for bass which avoids dynamic pushes...
			if(l>15.0)l=15.0;
			lowpass_r=l;

			l/=15.0;
			if (l < (-1*limitter) ) l = (-1*limitter);
			if (l > limitter) l = limitter;

			f2p0  = f2p0 + (TrebFreq * (spl1   - f2p0));
			f2p1  = f2p1 + (TrebFreq * (f2p0 - f2p1));
			f2p2  = f2p2 + (TrebFreq * (f2p1 - f2p2));
			f2p3  = f2p3 + (TrebFreq * (f2p2 - f2p3));

			h= sdm3 - f2p3;
			h=h*TrebGain;
			if(h>3.0)h=3.0;

			sdm3   = sdm2;
			sdm2   = sdm1;
			sdm1   = spl1;
			
			if(vbassEnabled)
			{
				if(btvelocity_r<=(l/(25.0/15.0)))
				{
					btvelocity_r=l/(25.0/15.0);
				}
				else
				{
					btvelocity_r-=0.000001;
				}
				spl1=(l/2.0)+((basstone*btvelocity_r)*vbass_gain)+(h/18.0);
			}else // vbass not enabled!
			{
				spl1=(h/18.0)+l;
			}


			spl0*=PreAmp*10.0;
			spl1*=PreAmp*10.0;

			left=spl0*(double)32767;
			right=spl1*(double)32767;

			if (left < -32768) left = -32768;
			if (left > 32767) left = 32767;
			if (right < -32768) right = -32768;
			if (right > 32767) right = 32767;

			a[0] = left;
			a[1] = right;
			a+=2;
		}
	}
	return numsamples;
}

int sf(int v)
{
    int res;
    res = v * (unsigned long)1103515245;
    res += (unsigned long)13293;
    res &= (unsigned long)0x7FFFFFFF;
    res ^= v;
	return res;
}

winampDSPHeader hdr = {DSP_HDRVER, "Citrus DSP for Winamp ", getModule, sf };

// first module
winampDSPModule mod =
{
	"Citrus DSP v1.0",
	NULL,	// hwndParent
	NULL,	// hDllInstance
	config,
	init,
	modify_samples,
	quit
};

extern "C"  __declspec( dllexport ) winampDSPHeader *winampDSPGetHeader2()
{
	return &hdr;
}

winampDSPModule *getModule(int which)
{
	switch (which)
	{
		case 0: return &mod;
		default:return NULL;
	}
}

void config(struct winampDSPModule *this_mod)
{
	ShowWindow(mainWindow,SW_SHOW);
	char strValue[16];
	wsprintfA(strValue,"%d", 1);
	WritePrivateProfileStringA("dsp_citrus","gui",strValue,confPath);	
}

int init(struct winampDSPModule *this_mod)
{
	hInstance=this_mod->hDllInstance;
	GetModuleFileNameA(this_mod->hDllInstance,confPath,MAX_PATH);
	char *p;
	for (p = confPath; *p; p++) { }	// find end
	for (; p > confPath && *p != '\\'; p--) { } // back up to last backslash
	*p = 0;	// kill it
	strcat(confPath,"\\plugin.ini");

	mainWindow=CreateDialog(this_mod->hDllInstance,MAKEINTRESOURCE(IDD_DIALOG1),this_mod->hwndParent,DialogProc);
	aboutWindow=CreateDialog(this_mod->hDllInstance,MAKEINTRESOURCE(IDD_DIALOG2),this_mod->hwndParent,AboutDialogProc);

	int posX=GetPrivateProfileIntA("dsp_citrus","x",0,confPath);
	int posY=GetPrivateProfileIntA("dsp_citrus","y",0,confPath);
	SetWindowPos(mainWindow,0,posX,posY,0,0,SWP_NOSIZE);

	int showWindow=GetPrivateProfileIntA("dsp_citrus","gui",1,confPath);
	if(showWindow)
	{
		ShowWindow(mainWindow,SW_SHOW);
	}
	return 0;
}

void quit(struct winampDSPModule *this_mod)
{
	DestroyWindow(aboutWindow);
	DestroyWindow(mainWindow);
}